
#include <string>
#include <rtm/CorbaNaming.h>
#include <rtm/RTObject.h>

int main(int argc, char* argv[])
{
	std::string ComponentName;
	if(argc == 2)
	{
		ComponentName = argv[1];
	}
	CORBA::ORB_var          orb;
	orb = CORBA::ORB_init(argc, argv);

       // Corba Consumer (RT component)
	RTC::CorbaConsumer<RTC::RTObject>    comp;
       // Corba Naming
	RTC::CorbaNaming nameserver(orb, "127.0.0.1:9876");
	// get from nameserver by name and set this object to RTC::CorbaConsumer
	try
	{
		comp.setObject(nameserver.resolve(ComponentName.c_str()));
	}
	catch(...)
	{
		std::cerr << "Resovle error" << std::endl;
		return -1;
	};

	RTC::PortList_var myports =  comp->get_ports();
	RTC::PortList* target;
	RTC::ConnectorProfileList_var connector;
	std::string portname, compname;
	std::cout << "-my port length " << myports->length() << std::endl;
	for(unsigned long i(0),j(0),k(0);i < myports->length() ; i++)
	{
		connector = myports[i]->get_connector_profiles();
		std::cout << "--Port : " << myports[i]->get_port_profile()->name << "\n"
			 << "  connector's profile length is " << connector->length() << std::endl;
		for(j=0; j < connector->length(); j++)
		{	
			target = &connector[j].ports;
			std::cout << "    connector[" << connector[j].name << "] registed " << target->length() << " ports" << std::endl;
			for(k=0; k < target->length(); k++)
			{
//					<< "<->" << target[i]->get_port_profile()->name
//					<< ":" <<  target[i]->get_port_profile()->owner->get_component_profile()->instance_name	
				std::cout 
					<< "     " << (*target)[i]->get_port_profile()->name;
				std::cout 
					<< " of " <<  (*target)[i]->get_port_profile()->owner->get_component_profile()->instance_name;
				std::cout 
					<< std::endl;
			}
		}
	}
}
